package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.exceptions.Ab79Exception;
import com.ejie.ab79.model.EnviosJson;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * EnviosJsonDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class EnviosJsonDaoImpl implements EnviosJsonDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDENVIOJSON", "APLICACIONORIGEN",
			"APLICACIONDESTINO", "IDINSPECTOR", "JSON", "ESTADO", "FECHAREGISTRO", "USUARIOREGISTRO", "METODO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<EnviosJson> rwMap = new RowMapper<EnviosJson>() {
		public EnviosJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new EnviosJson(resultSet.getInt("IDENVIOJSON"), resultSet.getString("APLICACIONORIGEN"),
					resultSet.getString("APLICACIONDESTINO"), resultSet.getInt("IDINSPECTOR"),
					resultSet.getString("METODO"), resultSet.getString("JSON"), resultSet.getInt("ESTADO"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"));
		}

	};

	private RowMapper<EnviosJson> rwMapPK = new RowMapper<EnviosJson>() {
		public EnviosJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new EnviosJson(resultSet.getInt("IDENVIOJSON"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<EnviosJson>> rwMapJerarquia = new RowMapper<JerarquiaDto<EnviosJson>>() {
		public JerarquiaDto<EnviosJson> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			EnviosJson enviosjson = new EnviosJson(resultSet.getInt("IDENVIOJSON"),
					resultSet.getString("APLICACIONORIGEN"), resultSet.getString("APLICACIONDESTINO"),
					resultSet.getInt("IDINSPECTOR"), resultSet.getString("METODO"), resultSet.getString("JSON"),
					resultSet.getInt("ESTADO"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<EnviosJson> jerarquia = new JerarquiaDto<EnviosJson>();
			jerarquia.setModel(enviosjson);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the EnviosJson table.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @return EnviosJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public EnviosJson add(EnviosJson enviosjson) {
		int idEnviosJson = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7934T00.NEXTVAL FROM DUAL",
				Integer.class);
		enviosjson.setIdEnvioJson(idEnviosJson);
		String query = "INSERT INTO ENVIOS_JSON (ID_ENVIO_JSON, APLICACION_ORIGEN, APLICACION_DESTINO, ID_INSPECTOR, METODO, JSON, ESTADO, FECHA_REGISTRO, USUARIO_REGISTRO, ERROR) VALUES (?,?,?,?,?,?,?,SYSDATE,?,?)";
		this.jdbcTemplate.update(query, idEnviosJson, enviosjson.getAplicacionOrigen(),
				enviosjson.getAplicacionDestino(), enviosjson.getIdInspector(), enviosjson.getMetodo(),
				enviosjson.getJson(), enviosjson.getEstado(), enviosjson.getUsuarioRegistro(), enviosjson.getError());
		return enviosjson;
	}

	/**
	 * Updates a single row in the EnviosJson table.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @return EnviosJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public EnviosJson update(EnviosJson enviosjson) {
		String query = "UPDATE ENVIOS_JSON SET APLICACION_ORIGEN=?, APLICACION_DESTINO=?, ID_INSPECTOR=?, METODO=?, JSON=?, ESTADO=? WHERE ID_ENVIO_JSON=?";
		this.jdbcTemplate.update(query, enviosjson.getAplicacionOrigen(), enviosjson.getAplicacionDestino(),
				enviosjson.getIdInspector(), enviosjson.getMetodo(), enviosjson.getJson(), enviosjson.getEstado(),
				enviosjson.getIdEnvioJson());
		return enviosjson;
	}

	/**
	 * Updates the status column of a single row in the EnviosJson table.
	 * 
	 * @param enviosJson
	 *            EnviosJson
	 * @return EnviosJson
	 * @throws Ab79Exception
	 */
	public EnviosJson updateEnviosJson(EnviosJson enviosJson) {
		String query = "UPDATE ENVIOS_JSON SET ESTADO = ? WHERE ID_ENVIO_JSON = ?";
		this.jdbcTemplate.update(query, enviosJson.getEstado(), enviosJson.getIdEnvioJson());

		return enviosJson;
	}

	/**
	 * Finds a single row in the EnviosJson table.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @return EnviosJson
	 */
	@Transactional(readOnly = true)
	public EnviosJson find(EnviosJson enviosjson) {
		String query = "SELECT t1.ID_ENVIO_JSON IDENVIOJSON, t1.APLICACION_ORIGEN APLICACIONORIGEN, t1.APLICACION_DESTINO APLICACIONDESTINO, t1.ID_INSPECTOR IDINSPECTOR, t1.METODO METODO, t1.JSON JSON, t1.ESTADO ESTADO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM ENVIOS_JSON t1  WHERE t1.ID_ENVIO_JSON = ?  ";

		List<EnviosJson> enviosjsonList = this.jdbcTemplate.query(query, this.rwMap, enviosjson.getIdEnvioJson());
		return (EnviosJson) DataAccessUtils.uniqueResult(enviosjsonList);
	}

	/**
	 * Removes a single row in the EnviosJson table.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @return
	 */
	public void remove(EnviosJson enviosjson) {
		String query = "DELETE FROM ENVIOS_JSON WHERE ID_ENVIO_JSON=?";
		this.jdbcTemplate.update(query, enviosjson.getIdEnvioJson());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<EnviosJson> getMultiple(EnviosJson filterEnviosJson, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterEnviosJson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, EnviosJson.class, params,
				"ID_ENVIO_JSON");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the EnviosJson table.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<EnviosJson>
	 */
	@Transactional(readOnly = true)
	public List<EnviosJson> findAll(EnviosJson enviosjson, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ENVIO_JSON IDENVIOJSON,t1.APLICACION_ORIGEN APLICACIONORIGEN,t1.APLICACION_DESTINO APLICACIONDESTINO,t1.ID_INSPECTOR IDINSPECTOR,t1.METODO METODO, t1.JSON JSON,t1.ESTADO ESTADO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM ENVIOS_JSON t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(enviosjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, EnviosJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<EnviosJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the EnviosJson table using like.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<EnviosJson>
	 */
	@Transactional(readOnly = true)
	public List<EnviosJson> findAllLike(EnviosJson enviosjson, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ENVIO_JSON IDENVIOJSON,t1.APLICACION_ORIGEN APLICACIONORIGEN,t1.APLICACION_DESTINO APLICACIONDESTINO,t1.ID_INSPECTOR IDINSPECTOR,t1.METODO METODO, t1.JSON JSON,t1.ESTADO ESTADO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM ENVIOS_JSON t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(enviosjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, EnviosJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<EnviosJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the EnviosJson table.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(EnviosJson enviosjson) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ENVIOS_JSON t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(enviosjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the EnviosJson table using like.
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(EnviosJson enviosjson, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ENVIOS_JSON t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(enviosjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of EnviosJson selected for rup_table
	 *
	 * @param enviosjson
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EnviosJson>>
	 */
	@Override
	public List<TableRowDto<EnviosJson>> reorderSelection(EnviosJson enviosjson, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ENVIO_JSON IDENVIOJSON,t1.APLICACION_ORIGEN APLICACIONORIGEN,t1.APLICACION_DESTINO APLICACIONDESTINO,t1.ID_INSPECTOR IDINSPECTOR,t1.METODO METODO, t1.JSON JSON,t1.ESTADO ESTADO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ENVIOS_JSON t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(enviosjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, EnviosJson.class,
				filterParamList, "ID_ENVIO_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<EnviosJson>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            EnviosJson
	 * @param searchParams
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EnviosJson>>
	 */
	@Override
	public List<TableRowDto<EnviosJson>> search(EnviosJson filterParams, EnviosJson searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ENVIO_JSON IDENVIOJSON,t1.APLICACION_ORIGEN APLICACIONORIGEN,t1.APLICACION_DESTINO APLICACIONDESTINO,t1.ID_INSPECTOR IDINSPECTOR,t1.METODO METODO, t1.JSON JSON,t1.ESTADO ESTADO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ENVIOS_JSON t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, EnviosJson.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_ENVIO_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<EnviosJson>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterenviosjson
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(EnviosJson filterenviosjson, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ENVIO_JSON IDENVIOJSON,t1.APLICACION_ORIGEN APLICACIONORIGEN,t1.APLICACION_DESTINO APLICACIONDESTINO,t1.ID_INSPECTOR IDINSPECTOR,t1.JSON JSON,t1.ESTADO ESTADO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ENVIOS_JSON t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterenviosjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, EnviosJson.class,
				query, params, "ID_ENVIO_JSON");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical EnviosJson table.
	 *
	 * @param filterEnviosJson
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<EnviosJson>>
	 */
	@Override
	public List<JerarquiaDto<EnviosJson>> findAllLikeJerarquia(EnviosJson filterEnviosJson,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ENVIO_JSON IDENVIOJSON,t1.APLICACION_ORIGEN APLICACIONORIGEN,t1.APLICACION_DESTINO APLICACIONDESTINO,t1.ID_INSPECTOR IDINSPECTOR,t1.JSON JSON,t1.ESTADO ESTADO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM ENVIOS_JSON t1 ");
		List<String> from = new ArrayList<String>();
		from.add("ENVIOS_JSON");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterEnviosJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_ENVIO_JSON", "ID_PADRE", "NOMBRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					EnviosJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterEnviosJson
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(EnviosJson filterEnviosJson, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM ENVIOS_JSON t1 ");
		List<String> from = new ArrayList<String>();
		from.add("ENVIOS_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterEnviosJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_ENVIO_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterEnviosJson
	 *            EnviosJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<EnviosJson>>
	 */
	@Override
	public List<TableRowDto<EnviosJson>> findAllChild(EnviosJson filterEnviosJson, TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM ENVIOS_JSON t1 ");
		List<String> from = new ArrayList<String>();
		from.add("ENVIOS_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterEnviosJson, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_ENVIO_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<EnviosJson>(this.rwMapPK, "ID_ENVIO_JSON"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the EnviosJson entity
	 *
	 * @param enviosjson
	 *            EnviosJson Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(EnviosJson enviosjson) {

		StringBuilder where = new StringBuilder(EnviosJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (enviosjson != null && enviosjson.getIdEnvioJson() != null) {
			where.append(" AND t1.ID_ENVIO_JSON = ?");
			params.add(enviosjson.getIdEnvioJson());
		}
		if (enviosjson != null && enviosjson.getAplicacionOrigen() != null) {
			where.append(" AND t1.APLICACION_ORIGEN = ?");
			params.add(enviosjson.getAplicacionOrigen());
		}
		if (enviosjson != null && enviosjson.getAplicacionDestino() != null) {
			where.append(" AND t1.APLICACION_DESTINO = ?");
			params.add(enviosjson.getAplicacionDestino());
		}
		if (enviosjson != null && enviosjson.getIdInspector() != null) {
			where.append(" AND t1.ID_INSPECTOR = ?");
			params.add(enviosjson.getIdInspector());
		}
		if (enviosjson != null && enviosjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(enviosjson.getEstado());
		}
		if (enviosjson != null && enviosjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(enviosjson.getFechaRegistro());
		}
		if (enviosjson != null && enviosjson.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(enviosjson.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the EnviosJson entity
	 *
	 * @param enviosjson
	 *            EnviosJson Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(EnviosJson enviosjson, Boolean startsWith) {

		StringBuilder where = new StringBuilder(EnviosJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (enviosjson != null && enviosjson.getIdEnvioJson() != null) {
			where.append(" AND t1.ID_ENVIO_JSON = ?");
			params.add(enviosjson.getIdEnvioJson());
		}
		if (enviosjson != null && enviosjson.getAplicacionOrigen() != null) {
			where.append(" AND UPPER(t1.APLICACION_ORIGEN) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(enviosjson.getAplicacionOrigen().toUpperCase() + "%");
			} else {
				params.add("%" + enviosjson.getAplicacionOrigen().toUpperCase() + "%");
			}
			where.append(" AND t1.APLICACION_ORIGEN IS NOT NULL");
		}
		if (enviosjson != null && enviosjson.getAplicacionDestino() != null) {
			where.append(" AND UPPER(t1.APLICACION_DESTINO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(enviosjson.getAplicacionDestino().toUpperCase() + "%");
			} else {
				params.add("%" + enviosjson.getAplicacionDestino().toUpperCase() + "%");
			}
			where.append(" AND t1.APLICACION_DESTINO IS NOT NULL");
		}
		if (enviosjson != null && enviosjson.getIdInspector() != null) {
			where.append(" AND t1.ID_INSPECTOR = ?");
			params.add(enviosjson.getIdInspector());
		}
		if (enviosjson != null && enviosjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(enviosjson.getEstado());
		}
		if (enviosjson != null && enviosjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(enviosjson.getFechaRegistro());
		}
		if (enviosjson != null && enviosjson.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(enviosjson.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + enviosjson.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
